-- **************************************************************************
--   TitanPalsUtils.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPals_CoreUtils( b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11 )
-- DESC : This makes everything happen
-- **************************************************************************
function TitanPals_CoreUtils( b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11 )
     local b = { [1] = b1, [2] = b2, [3] = b3, [4] = b4, [5] = b5, [6] = b6, [7] = b7, [8] = b8, [9] = b9, [10] = b10, [11] = b11, };
     if ( TitanPals.Debug.State ) then
          local tdLine
          for i = 1, 10 do
               if ( i == 1 ) then
                    if ( b[i] ) then tdLine = ( "[|cffff9900%s|r]" ):format( b[i] ); end
               else
                    if ( b[i] ) then tdLine = tdLine .. ( "[|cffff9900%s|r]" ):format( b[i] ); end
               end
          end
          TitanPals.Debug.dLine = ( "Recieved : %s" ):format( tdLine );
	  TitanPals_DebugUtils( "bug", "CoreUtils", TitanPals.Debug.dLine );
     end
     --collectgarbage( "collect" );
     if ( b[1] == "UpDate" ) then
          -- [b1    ][b2     ][b3   ][b4    ]
          -- [Action][Faction][Realm][Player]
          TitanPanelPals_SetUser();
          local NumPals = GetNumFriends();
          local Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno, fIndex;
          for fIndex = 1, NumPals do
               --[Name][Level][Class][Area][Connected][Status][Note]
               Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno = GetFriendInfo( fIndex );
               if ( not TitanPals.Lists[palsDB][Palsn] ) then TitanPals.Lists[palsDB][Palsn] = {}; end
               if ( not Palsco ) then 
                    if ( not TitanPals.Lists[palsDB][Palsn]["Level"] ) then TitanPals.Lists[palsDB][Palsn]["Level"] = Palsl; end
                    if ( not TitanPals.Lists[palsDB][Palsn]["Class"] ) then TitanPals.Lists[palsDB][Palsn]["Class"] = Palsc; end
                    if ( not TitanPals.Lists[palsDB][Palsn]["Note"] ) then TitanPals.Lists[palsDB][Palsn]["Note"] = "na"; end
               else
                    TitanPals.Lists[palsDB][Palsn]["Level"] = Palsl;
                    TitanPals.Lists[palsDB][Palsn]["Class"] = Palsc;
                    if ( not Palsno ) then
                         TitanPals.Lists[palsDB][Palsn]["Note"] = "na";
                    else
                         TitanPals.Lists[palsDB][Palsn]["Note"] = Palsno;
                    end
               end
          end
     elseif ( b[1] == "ToolTipN" ) then
          --[b1    ][b2   ][b3  ][b4  ][b5   ][b6   ][b7  ][b8    ][b9  ][b10    ]
          --[Action][Right][Left][Name][Level][Class][Area][Status][Note][Offline]
          --[[ !s - Status ][ !l - Level ][ !p - Player ][ !z - Zone ][ !n - Note ][ !c - Class ][ !uc - Colored Players Name ]]--
          if ( b[5] == 0 ) then b[5] = "-"; end
          if ( string.match( b[8], "(.*):(.*)" ) ) then
               local BNA, BND = string.match( b[8], "(.*):(.*)" );
               if ( BNA == "nil" ) then BNA = nil; end
               if ( BND == "nil" ) then BND = nil; end
               if ( BNA or BND ) then
                    if ( BNA ) then b[2] = string.gsub( b[2], "!s", TitanPals.Settings.SFormat ); end
                    if ( BND ) then b[2] = string.gsub( b[2], "!s", TitanPals.Settings.DFormat ); end
               else
                    b[2] = string.gsub( b[2], "!s", " " );
               end
          else
               if ( b[8] == "<AFK>" or b[8] == "<Away>" or b[8] == "<DND>" or b[8] == "<ALT>" or b[8] == "<Busy>" ) then
                    if ( b[8] == "<Away>" ) then
                         b[8] = TitanPals.Settings.SFormat;
                    elseif ( b[8] == "<DND>" or b[8] == "<Busy>" ) then
                         b[8] = TitanPals.Settings.DFormat;
                    end
                    b[2] = string.gsub( b[2], "!s", b[8] );
               else
                    b[2] = string.gsub( b[2], "!s", " " );
               end
          end
          if ( b[5] == "SC2" ) then
               b[2] = string.gsub( b[2], "!l", TitanPals_ColorUtils( "GetCText", "gray", b[5] ) );
          else
               b[2] = string.gsub( b[2], "!l", TitanPals_ColorUtils( "GetCText", "orange", b[5] ) );
          end
          b[2] = string.gsub( b[2], "!p", TitanPals_ColorUtils( "GetCText", "orange", b[4] ) );
          b[2] = string.gsub( b[2], "!c", TitanPals_ColorUtils( "GetCClass", b[6], b[6] ) );
          if ( not b[9] ) then
               b[2] = string.gsub( b[2], "!n", "" );
          else
               b[2] = string.gsub( b[2], "!n", TitanPals_ColorUtils( "GetCText", "gray", b[9] ) );
          end
          if ( b[7] ) then
               b[2] = string.gsub( b[2], "!z", b[7] );
          else
               b[2] = string.gsub( b[2], "!z", b[10] );
          end
          b[2] = string.gsub( b[2], "!uc", TitanPals_ColorUtils( "GetCClass", b[6], b[4] ) )
          -- TitanPals_DebugUtils( "bug", "ToolTipN", b[2] )
          b[11], b[12] = string.match( b[2], "(.*)~(.*)" )
          return b[11], b[12];
     elseif ( b[1] == "ToolTipID" ) then
          --[b1    ][b2    ][b3        ][b4       ][b5       ][b6        ][b7       ][b8   ][b9    ]
          --[Action][Format][First Name][Last Name][Character][Realm Name][Full Name][Class][Client]
          b[2] = string.gsub( b[2], "!sn", TitanPals_ColorUtils( "GetCClass", b[8], b[3] ) );
          b[2] = string.gsub( b[2], "!ln", TitanPals_ColorUtils( "GetCClass", b[8], b[4] ) );
          b[2] = string.gsub( b[2], "!cn", TitanPals_ColorUtils( "GetCClass", b[8], b[5] ) );
          b[2] = string.gsub( b[2], "!rn", TitanPals_ColorUtils( "GetCClass", b[8], b[6] ) );
          b[2] = string.gsub( b[2], "!fn", TitanPals_ColorUtils( "GetCClass", b[8], b[7] ) );
          b[2] = string.gsub( b[2], "!gn", TitanPals_ColorUtils( "GetCText", "gray", b[9] ) );
          return b[2];
     elseif ( b[1] == "DisplayB" ) then
          --[b1    ]
          --[Action]
          UpdateAddOnMemoryUsage();
          TitanPals.Debug.dLine = ( "%s kb" ):format( floor( GetAddOnMemoryUsage( "TitanPals" ) ) );
          TitanPals_DebugUtils( "info", "load", LB["TITAN_PALS_CONFIG_BANNOR_FORMAT"]:format( LB["TITAN_PALS_ADDON_LABEL"], LB["TITAN_PALS_CORE_VERSION"], TitanPals.Debug.dLine ) );
     elseif ( b[1] == "fixClass" ) then
          --[b1    ][b2  ][b3   ]
          --[Action][Name][Class]
          TitanPals_DebugUtils( "info", "fixClass", ( "Name = %s Class = %s" ):format( b[2], b[3] ) );
          TitanPals.Lists[palsDB][b[2]] = b[3];
     elseif ( b[1] == "MakeSafe" ) then
          local text
          if ( b[2] == true ) then text = "true"; end
          if ( b[2] == false ) then text = "false"; end
          if ( b[2] == nil ) then text = "nil"; end
          return text;
     elseif ( b[1] == "playFriends" ) then
          --[b1    ]
          --[Action]
          local pTable = TitanPals.Lists[palsDB];
          for n, v in pairs( pTable ) do
               local name = TitanPals_ColorUtils( "GetCClass", v.Class, n );
               local level = TitanPals_ColorUtils( "GetCText", "hlight", ( "%s" ):format( v.Level ) );
               TitanPals_DebugUtils( "info", b[1], ( "(%s) %s" ):format( level, name ) );
          end
     elseif ( b[1] == "playAlts" ) then
          --[b1    ]
          --[Action]
	  local pTable = TitanPals.Alts[palsDB];
          for n, v in pairs( pTable ) do
               local name = TitanPals_ColorUtils( "GetCClass", v, n );
	       local class = TitanPals_ColorUtils( "GetCClass", v, ( "%s" ):format( v ) );
               TitanPals_DebugUtils( "info", b[1], ( "(%s) %s" ):format( class, name ) );
          end
     elseif ( b[1] == "Author" ) then
           local Authors = {
               ["Lindarena@Laughing Skull"] = true,
               ["Stâbsâlot@Laughing Skull"] = true,
               ["Hilyna@Laughing Skull"] = true,
               ["Nagdand@Laughing Skull"] = true,
               ["Holycurves@Laughing Skull"] = true,
               ["Holytree@Laughing Skull"] = true,
               ["Acatra@Laughing Skull"] = true,
               ["Nâsh@Laughing Skull"] = true,
               ["Loansone@Laughing Skull"] = true,
               ["Koton@Laughing Skull"] = true,
          }
          for i = 1, getn( TitanPals.AddAuth ) do
               if ( not Authors[TitanPals.AddAuth[i]] ) then
                    Authors[TitanPals.AddAuth[i]] = true;
               else
                    tremove( TitanPals.AddAuth, i );
                    TitanPals_DebugUtils( "bug", "AddAuth", "Can Not Add Author Already Exists!" )
               end
          end
          return Authors[b[2]];
     elseif ( b[1] == "AddAuth" or b[1] == "addauth" ) then
          b[2] = ( "%s@%s" ):format( TitanPals.Profile.Player, TitanPals.Profile.Realm );
          TitanPals_DebugUtils( "info", "CoreUtils", LB["TITAN_PALS_CORE_ADDAUTHOR"]:format( b[2] ) );
          tinsert( TitanPals.AddAuth, b[2] );
     elseif ( b[1] == "RemAuth" or b[1] == "remauth" ) then
          b[2] = ( "%s@%s" ):format( TitanPals.Profile.Player, TitanPals.Profile.Realm );
          for i = 1, getn( TitanPals.AddAuth ) do
               if ( b[2] == TitanPals.AddAuth[i] ) then
                    TitanPals_DebugUtils( "info", "CoreUtils", LB["TITAN_PALS_CORE_REMAUTHOR"]:format( b[2] ) );
                    tremove( TitanPals.AddAuth, i );
               end
          end
     elseif ( b[1] == "buildLocals" ) then
          if ( TitanPals.Debug.State ) then PlaySoundFile("Sound\\Character\\Dwarf\\DwarfMaleErrorMessages\\DwarfMale_err_bagfull01.wav") end
          TitanPalsLocalClass = {};
          TitanPalsColorClass = {};
          TitanPalsToEng = {};
          local localClass = {};
          local sex, gender
          for i = 1, 2 do
               if ( i == 1 ) then sex = true;
               elseif ( i == 2 ) then sex = false; end
               FillLocalizedClassList( localClass, sex );
               for token, localName in pairs( localClass ) do
                    local color = RAID_CLASS_COLORS[token];
                    local colorCode = ( "%02x%02x%02x" ):format( ( color.r * 255 ), ( color.g * 255 ), ( color.b * 255 ) );
                    local richText = ( "|cff%s%%s|r" ):format( colorCode );
                    TitanPals_DebugUtils( "bug", "LCT", richText );
                    if ( sex ) then
                         gender = ( "%s_TRUE" ):format( token );
                         TitanPalsColorClass[gender] = richText;
                         TitanPalsLocalClass[gender] = localName;
                         TitanPalsToEng[localName] = gender;
                    else
                         gender = ( "%s_FALSE" ):format( token );
                         TitanPalsColorClass[gender] = richText;
                         TitanPalsLocalClass[gender] = localName;
                         TitanPalsToEng[localName] = gender;
                    end
               end
          end
     elseif ( b[1] == "checkEdit" ) then
          local tReturn = {};
          local nEdit = false;
          local fList = TitanPals.Lists[palsDB]
          for n, v in pairs( fList ) do
               if ( v.Level == 0 or v.Class == "Unknown" ) then
                    nEdit = true;
                    tinsert( tReturn, { name = n, value = n, } );
               end
          end
          if ( b[2] == "_true" ) then return nEdit, tReturn;
          else return nEdit; end
     end
end

-- **************************************************************************
-- NAME : TitanPals_DebugUtils( d1, d2, d3, d4, d5 )
-- DESC : For debug messaging and print messages to chat frame
-- **************************************************************************
function TitanPals_DebugUtils( d1, d2, d3, d4, d5 )
     local d = { [1] = d1, [2] = d2, [3] = d3, [4] = d4, [5] = d5, };
     --[d1    ][d2      ][d3   ]
     --[Action][Function][error]
     if ( d[1] == "info" ) then
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_ITAG"]:format( d[3] ) );
     elseif ( d[1] == "error" ) then
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_ETAG"]:format( d[3] ) );
     elseif ( d[1] == "bug" and TitanPals.Debug.State ) then
          local fError = ( "[|cffff9900%s|r] %s" ):format( d[2], d[3] );
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_DTAG"]:format( fError ) );
          if ( TitanPals.Debug.LogEvent ) then tinsert( TitanPals.Temp, d[3] ); end
     end
end

-- **************************************************************************
-- NAME : TitanPals_ResetUtils( r1, r2, r3, r4, r5 )
-- DESC : Diffrent was to reset Data Array
-- **************************************************************************
function TitanPals_ResetUtils( r1, r2, r3, r4, r5 )
     local r = { [1] = r1, [2] = r2, [3] = r3, [4] = r4, [5] = r5, };
     --[r1    ][r2    ]
     --[reload][action]
     if ( r[2] == "reset" ) then
          TitanPals = nil;
     elseif ( r[2] == "checkDB" ) then
          TitanPalsInit = false;
          TitanPals_Init( true );
          TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
          TitanPanelButton_UpdateTooltip();
     end
     if ( r[1] ) then ReloadUI(); end
end

-- **************************************************************************
-- NAME : TitanPals_ColorUtils( c1, c2, c3, c4, c5 )
-- DESC : for coloring the tooltip and messages
-- **************************************************************************
function TitanPals_ColorUtils( c1, c2, c3, c4, c5 )
     local c = { [1] = c1, [2] = c2, [3] = c3, [4] = c4, [5] = c5, };
     if ( c[1] == "GetCText" ) then
          --[c1    ][c2   ][c3  ]
          --[Action][Color][Text]
          local color = strupper( c[2] )
          local colorCode
          local colorCache = {
               GREEN = "|cff00ff00%s|r",
               BLUE = "|cff00ffff%s|r",
               GRAY = "|cff808080%s|r",
               HLIGHT = "|cffffffff%s|r",
               NORMAL = "|cffffd200%s|r",
               ORANGE = "|cffff9900%s|r",
               RED = "|cffff0000%s|r",
          }
          colorCode = colorCache[color]:format( c[3] );
          return colorCode;
     elseif ( c[1] == "GetCClass" ) then
          --[c1    ][c2   ][c3    ]
          --[Action][Class][Player]
          local classEng, localClass, colorCode;
          classEng = TitanPalsToEng[c[2]];
          localClass = TitanPalsLocalClass[classEng];
          colorCode = TitanPalsColorClass[classEng];
          return colorCode:format( c[3] );
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_StaticPopup( notesAdd )
-- DESC : Dialog for custom Notes
-- **************************************************************************

function TitanPanelPals_StaticPopup( notesAdd )
     StaticPopupDialogs["TITAN_PALS_CUSTOM_NOTE"] = {
          text = LB["TITAN_PALS_STATIC_ADDNOTE"],
          button1 = TEXT( ACCEPT ),
          button2 = TEXT( CANCEL ),
          hasEditBox = 1,
          maxLetters = 250,
          OnAccept = function( self )
               local pNote = self.editBox:GetText();
               if ( notesAdd.Type == "Normal" ) then
                    SetFriendNotes( notesAdd.Player, pNote )
               elseif ( notesAdd.Type == "BNet" ) then
                    BNSetFriendNote( notesAdd.pID, pNote );
               end
          end,
          OnShow = function( self )
               self.editBox:SetFocus();
          end,
          OnHide = function( self )
               self.editBox:SetText( "" );
          end,
          EditBoxOnEnterPressed = function( self )
               local parent = self:GetParent();
               local pNote = parent.editBox:GetText();
               self:GetParent():Hide();
          end,
          EditBoxOnEscapePressed = function( self )
               self:GetParent():Hide();
          end,
          timeout = 0,
          exclusive = 1,
          whileDead = 1,
          hideOnEscape = 1
     };
     StaticPopup_Show( "TITAN_PALS_CUSTOM_NOTE", notesAdd.PlayerColored );
end


function TitanPals_LocalColorTest()
     TitanPalsLocalClass = {};
     TitanPalsColorClass = {};
     TitanPalsToEng = {};
     local localClass = {};
     local sex, gender
     for i = 1, 2 do
          if ( i == 1 ) then sex = true;
          elseif ( i == 2 ) then sex = false; end
          FillLocalizedClassList( localClass, sex );
          for token, localName in pairs( localClass ) do
               local color = RAID_CLASS_COLORS[token];
               local colorCode = ( "%02x%02x%02x" ):format( ( color.r * 255 ), ( color.g * 255 ), ( color.b * 255 ) );
               local richText = ( "|cff%s%%s|r" ):format( colorCode );
               TitanPals_DebugUtils( "bug", "LCT", richText );
               if ( sex ) then
                    gender = ( "%s_TRUE" ):format( token );
                    TitanPalsColorClass[gender] = richText;
                    TitanPalsLocalClass[gender] = localName;
                    TitanPalsToEng[localName] = gender;
               else
                    gender = ( "%s_FALSE" ):format( token );
                    TitanPalsColorClass[gender] = richText;
                    TitanPalsLocalClass[gender] = localName;
                    TitanPalsToEng[localName] = gender;
               end
          end
     end
end